.. _overview:

.. contents::
    :depth: 2

Architecture Overview
==================================================

We first provide a brief overview of the code's structure, and what different objects accomplish.
More details are available in the corresponding sections listed below.

Events
--------------------------------------------------

:class:`gwdistributions.events.Event` represents our basic concept of a GW event.
That is, it records a set of single-event parameters (e.g., masses, spins, redshift) we associate with a particular event.
Collections of events represent ensembles of GW sources, and can be used for a variety of purposes.

Within GWDistributions, events are drawn from distributions encoded within instances of :class:`gwdistribuitons.distributions.base.SamplingDistribution` that are appended within a :class:`gwdistribuitons.generators.EventGenerator`.
Similarly, :class:`gwdistribuitons.generators.EventGenerator` can assign probabilities to the single-event parameters stored in an event by iteratively delegating to various :class:`gwdistribuitons.distributions.base.SamplingDistribution` instances.

Read more here: :ref:`event`.

Sampling Distributions
--------------------------------------------------

:class:`gwdistribuitons.distributions.base.SamplingDistribution` is the basic encapsulation of a probability distribution within GWDistributions.
Specifically, different subclasses define different parametrized distributions over separate sets of variates (single-event parameters like masses and spins).
Users can instantiate these objects, setting the parametrizations' hyperparameters at instantiation-time.
Once a distribuiton is instantiated, users can

  * draw samples from the parametrizations with :meth:`gwdistributions.distributions.base.SamplingDistribution.rvs`
  * compute the probability at particular points in parameter space with :meth:`gwdistributions.distributions.base.SamplingDistribution.prob` or :meth:`gwdistributions.distributions.base.SamplingDistribution.logprob`
  * compute the Jacobian (first derivative of the probability distribution with respect to its hyperparameters) via :meth:`gwdistributions.distributions.base.SamplingDistribution.jacobian`
  * compute the Hessian (matrix of 2nd order derivatives of the probability distribution with respect to its hyperparameters) via :meth:`gwdistributions.distributions.base.SamplingDistribution.hessian`
  * update hyperparameters via :meth:`gwdistributions.distributions.base.SamplingDistribution.update`

Additionally, distributions over one set of variates (e.g., masses) can be conditioned on another set of variates (e.g., redshift).
Several distributions over the same set of variates can also be combined into a mixture model.

Logic for creating sensible joint distributions out of sets of separate (conditional) distributions is achieved with :class:`gwdistributions.generators.EventGenerator` (see below).

Read more here: :ref:`distributions`.

Attribute Transformations
--------------------------------------------------

:class:`gwdistributions.transforms.base.AttributeTransformation` computes a set of dependent variates given a set of variates generated by instances of :class:`gwdistribuitons.distributions.base.SamplingDistribution`.
Different subclasses implement different transformations.
These can be simple, like computing the chirp mass and mass ratio from the component masses, or more complex, like computing the probability that a system will be detected based on its single-event parameters, a waveform model, and a detector network.

Read more here: :ref:`transforms`.

Generators
--------------------------------------------------

:class:`gwdistributions.generators.EventGenerator` represents joint distributions over several variates.
While this concept could be accomplished by defining separate :class:`gwdistribuitons.distributions.base.SamplingDistribution` for each possible set of variates and parametrizations, EventGenerators allow the user to combine distributions over subsets of variates without repeating code.
Indeed, EventGenerators embody the concept of a modular joint probability distribution, which is the core deliverable within GWDistributions.

Read more here: :ref:`generators`.
